ImmunityChecker = class(Turbine.UI.Window)
function ImmunityChecker:Constructor()
    Turbine.UI.Window.Constructor(self);
    local width = Settings.IWidth
    local height = Settings.IHeight
    local x = Settings.IX
    local y = Settings.IY

    local cooldownTimer = 0
    local oldGameTime = Turbine.Engine.GetGameTime()
    local Timers = {}

    
    local UpdateDelay = 0
    local UpdateTime = 0.4

    local TimerHeight = 20

    self.TargetEffects = nil
    self.Target = nil

    self:SetSize(width,height);
    self:SetPosition(x,y);
    self:SetVisible(true)
    self:SetWantsUpdates(true)
    self:SetMouseVisible(false)
    --self:SetBackColor(GoldColor)

    self.NameLabel = Turbine.UI.Label()
    self.NameLabel:SetParent(self)
    self.NameLabel:SetSize(width, 20)
    self.NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.NameLabel:SetMouseVisible(false)
    if Player:GetTarget() ~= nil then
        self.NameLabel:SetText(Player:GetTarget():GetName())
    else
        self.NameLabel:SetText("No target")
    end

    self.TimerContainer = Turbine.UI.Control()
    self.TimerContainer:SetParent(self)
    self.TimerContainer:SetVisible(true)
    self.TimerContainer:SetSize(100, height - 20)
    self.TimerContainer:SetPosition(0, 20)
    self.TimerContainer:SetMouseVisible(false)

    self.MoveBox = Turbine.UI.Control()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(width, height)
    self.MoveBox:SetBackColor(Turbine.UI.Color(0, 1, 0))
    self.MoveBox:SetVisible(false)

    self.messageBox1 = Turbine.UI.Label()
    self.messageBox1:SetParent(self.MoveBox)
    self.messageBox1:SetSize(width, height)
    self.messageBox1:SetPosition(0,0)
    self.messageBox1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox1:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.messageBox1:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox1:SetMouseVisible(false)
    self.messageBox1:SetText("Immunities")

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          if newLeft < 0 then newLeft = 0 end
          if newTop < 0 then newTop = 0 end
          if newLeft > (Turbine.UI.Display.GetWidth() - self:GetWidth()) then
            newLeft = Turbine.UI.Display.GetWidth() - self:GetWidth() end
          if newTop > (Turbine.UI.Display.GetHeight() - self:GetHeight()) then
            newTop = Turbine.UI.Display.GetHeight() - self:GetHeight() end
          self:SetPosition(newLeft,newTop)
        end
    end
    
    self.ToggleMove = function()
        self.MoveBox:SetVisible(not self.MoveBox:IsVisible())
    end

    self.UpdateEffects = function()
        if self.TargetEffects == nil then return end
        --ChatOutput( "L")
        local targetEffects = self.TargetEffects
        for i = 1, targetEffects:GetCount() do
            local target = targetEffects:Get(i)
            local targetName = target:GetName()
            --ChatOutput(targetName)
            if Effects[targetEffects:Get(i):GetName()] ~= nil then
                local temp = Effects[targetEffects:Get(i):GetName()] 
                self.NewTimer(target:GetDuration() - (Turbine.Engine.GetGameTime() - target:GetStartTime()),
                    temp[1], 
                    temp[1], true, false, false, temp[3], target:GetDuration(), target)
            end
        end
        if targetEffects:GetCount() > 0 then
            self.ReOrder()
        end

        --PrintTable(Timers)
    end

    self.TargetEvents = function()
        --[[
        local target = Player:GetTarget()
        if target ~= nil and target.GetLevel ~= nil then
            self.NameLabel:SetText(target:GetName())
            local effectList = target:GetEffects()
            for i = 1, effectList:GetCount(), 1 do
                if Effects[effectList:Get(i):GetName()] ~= nil then
                    local temp = Effects[effectList:Get(i):GetName()]
                    self.NewTimer(effectList:Get(i):GetDuration() - (Turbine.Engine.GetGameTime() - effectList:Get(i):GetStartTime()), temp[1], temp[1], true, false, false, temp[3], effectList:Get(i):GetDuration())
                end
            end

            effectList.EffectAdded = function(sender, args)
                if Effects[effectList:Get(args.Index):GetName()] ~= nil and Player:GetTarget() ~= nil and Player:GetTarget():GetName() == self.NameLabel:GetText() then
                    local temp = Effects[effectList:Get(args.Index):GetName()]
                    self.NewTimer(effectList:Get(args.Index):GetDuration() - (Turbine.Engine.GetGameTime() - effectList:Get(args.Index):GetStartTime()), temp[1], temp[1], true, false, false, temp[3], effectList:Get(args.Index):GetDuration())
                end
            end

        else
            self.NameLabel:SetText("No target")
        end
        --]]

        local target = Player:GetTarget()
        if target ~= nil and target.GetLevel ~= nil then

            self.NameLabel:SetText(target:GetName())
            self.Target = Player:GetTarget()
            self.TargetEffects =  self.Target:GetEffects()
            self.TargetEffects.self = self
            UpdateDelay = 0
        else
            self.NameLabel:SetText("No target")
            self.TargetEffects = nil
            self.Target = nil
        end
    end

    Player.TargetChanged = function()
        self.Clear()
        self.TargetEvents()
    end

    self.Update = function(sender, args)   
        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == oldGameTime then
            return(true)
        end
        local delta = currentGameTime - oldGameTime

        UpdateDelay = UpdateDelay - delta

        if UpdateDelay < 0 then
            self.UpdateEffects()
            UpdateDelay = UpdateTime
        end

        --We had an update
        for key, value in pairs(Timers) do 
            value[2] = value[2] - delta
            --ChatOutput(value[2])
            if value[2] < 0 then 
                --PrintTable(Timers)
                --ChatOutput("Delete ID: " .. key)
                Timers[key] = nil
                table.remove(Timers, key )
                --PrintTable(Timers)
                value[1]:Destroy()
                self.ResortList()
            end
            --value[1]:SetText(value[3].." "..value[2])
            value[1]:UpdateText()
        end
        oldGameTime = currentGameTime
    end

    -- Add a timer
    self.NewTimer = function(duration, effectName, message, unique, activityTimer, showActivity, icon, maxDuration)
        --self:SetWantsUpdates(true)
        --ChatOutput(duration)
        --ChatOutput(maxDuration)
        local count = Tablelength(Timers)
        if unique then
            if activityTimer == nil then ChatOutput("Nill timer for: " .. effectName) end
            for key, value in pairs(Timers) do
                --ChatOutput(value[4] .. " " .. message)
                if value[4] == message then 
                    value[2] = duration
                    value[1]:ChangeDuration(duration)
                    --ChatOutput("Return")
                    return
                end
            end
        end
        --ChatOutput("TTT")

        table.insert( Timers, {Counter(self.TimerContainer, width, Settings.SPTimerHeight2, count, maxDuration, message, Settings.SPNewFont, TimerColourNormal1, TimerColourNormal2, TimerColourNormal3, TimerColourNormal4, TimerColourNormal5, icon), maxDuration, message, effectName, unique})
        for key, value in pairs(Timers) do
            --ChatOutput(value[4] .. " " .. message)
            if value[4] == message then 
                value[2] = duration
                value[1]:ChangeDuration(duration)
                --ChatOutput("Return")
                --return
            end
        end
        --ChatOutput(Tablelength(Timers))
            --Timers[ID] =  {Counter(self, width, height, count, duration, message), duration, message}

        --ID = ID + 1
        self.ReOrder()
        --PrintTable(Timers)
    end

    self.Clear = function()
        for key, value in pairs(Timers) do 
            Timers[key] = nil
            table.remove(Timers, key )
            --PrintTable(Timers)
            value[1]:Destroy()
        end
        if Tablelength(Timers) > 0 then
            self.Clear()
        end
    end

    self.ReOrder = function()
        if Tablelength(Timers) > 1 then  
            table.sort(Timers, Compare)
        end
        local counter = 0
        --ChatOutput("Reorder")
        for key, value in pairs(Timers) do
            --ChatOutput(value[2])
            value[1]:SetPosition(0, counter * Settings.SPTimerHeight2)
            counter = counter + 1
        end
    
        if Tablelength(Timers) > 0 then
            --self.Clear()
        end
    
        --PrintTable(Timers)
    end
    
    self.ResortList = function()
        --ChatOutput("Resort")
        local counter = 0
        for key, value in pairs(Timers) do
            value[1]:SetPosition(0, counter * Settings.SPTimerHeight2) 
            counter = counter + 1
        end
    end

    self.TargetEvents()
end