Settings = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeBarrageSettings")

function GetDefaultSettings()
    Settings = {}

    Settings.SPWidth = 200
    Settings.SPHeight = 500
    Settings.SPX = 0
    Settings.SPY = 0
    Settings.SPItemWidth = Settings.SPWidth
    Settings.SPItemHeight = Settings.SPHeight
    Settings.SPEnabled = true
    Settings.SPFont = Turbine.UI.Lotro.Font.TrajanProBold24
    Settings.SPTimers = Turbine.UI.Lotro.Font.TrajanProBold36
    Settings.SPNewFont = Turbine.UI.Lotro.Font.TrajanPro14
    Settings.SPTimerWidth = Settings.SPWidth
    Settings.SPTimerHeight = 32
    Settings.SPTimerHeight2 = 34
    Settings.SPOpacity = 1

    Settings.SPAX = 0
    Settings.SPAY = 0
    Settings.SPAWidth = 200
    Settings.SPAHeight = 300
    Settings.SPAEnabled = true

    Settings.IWidth = 150
    Settings.IHeight = 300
    Settings.IX = 500
    Settings.IY = 500

    Settings.Reload = false
    Settings.Version = plugin:GetVersion()

end

if Settings == nil or Settings.Reload == true then
    GetDefaultSettings()
end

function UpdateSettings()
    local tempSettings = Settings
    GetDefaultSettings()
    for key, value in pairs(tempSettings) do
        if Settings[key] ~=  nil then
            Settings[key] = value
        end
    end
    Settings.Version = plugin:GetVersion()
end

function SaveData()
    Settings.SPX, Settings.SPY = BarrageTimers:GetPosition()
    Settings.SPAX, Settings.SPAY = BarrageTimers:GetPosition()
    --Settings.IX, Settings.IY = Immunities:GetPosition()

    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeBarrageSettings", Settings);
end

--Colour settings

GoldColor = Turbine.UI.Color(255, 153, 0)

OutlineColor = Turbine.UI.Color(0, 0, 0)

TimerColourNormal1 = Turbine.UI.Color(1,0,0)
TimerColourNormal2 = Turbine.UI.Color(0.5,0,0)
TimerColourNormal3 = Turbine.UI.Color(0,0.125,0.5)
TimerColourNormal4 = Turbine.UI.Color(0,0.8,0.2)
TimerColourNormal5 = Turbine.UI.Color(0,0.5,0.1)

TimerColourActive1 = Turbine.UI.Color(1,0,0)
TimerColourActive2 = Turbine.UI.Color(0.5,0,0)
TimerColourActive3 =  Turbine.UI.Color(0.5,0,0)
TimerColourActive4 =  Turbine.UI.Color(0.5,0,0)
TimerColourActive5 =  GoldColor

-- Icon
BarrageIcon = "PrimePlugins/BarrageTracker/Images/Steadfast_Barrage-icon.jpg"

-- Tracking effects
-- Message / maxduration / icon
Effects = {
    ["Daze and Stun Immunity"] = {"Daze/Stun", 5, 1090526136},
    ["Root Immunity"] = {"Root", 5, 1090526132},
    ["Fear Immunity"] = {"Fear", 5, 1091428830},
    ["Immunity"] = {"All", 10, 1091423617},
    ["Temporary State Immunity"] = {"Temp All", 9, 1091423618},
    ["Continuous Blood Rage"] = {"CBR", 88, 1091522569},
    ["Juggernaut"] = {"Jugg", "XD", 1091805299},
    ["Tactically Sound"] = {"All", nil, 1090541176}
}