Timer = class(Turbine.UI.Window)
function Timer:Constructor()
    local width = 0
    local height = 0
    local x = 0
    local y = 0

    width = Settings.SPAWidth
    height = Settings.SPAHeight
    x = Settings.SPAX
    y = Settings.SPAY
    local cooldownTimer = 0
    local oldGameTime = Turbine.Engine.GetGameTime()
    local Timers = {}
    local ID = 0
    local clearTimer = 0
    Turbine.UI.Window.Constructor(self);
    self:SetSize(width,height);
    self:SetPosition(x,y);
    self:SetZOrder(1);

    self:SetWantsKeyEvents(true)
    self:SetMouseVisible(false)
    self:SetVisible(true)
    self:SetWantsUpdates(true)

    self.messageBox = Turbine.UI.Label()
    self.messageBox:SetParent(self)
    self.messageBox:SetSize(width,height)
    self.messageBox:SetPosition(0,0)
    self.messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox:SetFont(Settings.SPFont)
    self.messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox:SetMouseVisible(false)
    self.messageBox:SetVisible(false)
  
    self.MoveBox = Turbine.UI.Control()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(width, height)
    self.MoveBox:SetBackColor(Turbine.UI.Color(1, 0, 0))
    self.MoveBox:SetVisible(false)

    self.messageBox1 = Turbine.UI.Label()
    self.messageBox1:SetParent(self.MoveBox)
    self.messageBox1:SetSize(width, height)
    self.messageBox1:SetPosition(0,0)
    self.messageBox1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox1:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.messageBox1:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox1:SetMouseVisible(false)
    self.messageBox1:SetText("Barrage timers")

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          if newLeft < 0 then newLeft = 0 end
          if newTop < 0 then newTop = 0 end
          if newLeft > (Turbine.UI.Display.GetWidth() - self:GetWidth()) then
            newLeft = Turbine.UI.Display.GetWidth() - self:GetWidth() end
          if newTop > (Turbine.UI.Display.GetHeight() - self:GetHeight()) then
            newTop = Turbine.UI.Display.GetHeight() - self:GetHeight() end
          self:SetPosition(newLeft,newTop)
        end
    end
    
    self.ToggleMove = function()
        self.MoveBox:SetVisible(not self.MoveBox:IsVisible())
    end

    self.Update = function(sender, args)   

        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == oldGameTime then
            return(true)
        end
        local delta = currentGameTime - oldGameTime

        --We had an update
        for key, value in pairs(Timers) do 
            value[2] = value[2] - delta
            if value[2] < 0 then 
                --PrintTable(Timers)
                --ChatOutput("Delete ID: " .. key)
                Timers[key] = nil
                table.remove(Timers, key )
                --PrintTable(Timers)
                value[1]:Destroy()
                self.ResortList()
            end
            --value[1]:SetText(value[3].." "..value[2])
            value[1]:UpdateText()
        end
    
        oldGameTime = currentGameTime
    end

    -- Add a timer
    self.NewTimer = function(x, duration, effectName, message, unique, activityTimer, showActivity, icon)
        local count = Tablelength(Timers)
        if unique then
            if activityTimer == nil then ChatOutput("Nill timer for: " .. effectName) end
            for key, value in pairs(Timers) do
                --ChatOutput(value[4] .. " " .. message)
                if value[4] == message then 
                    value[2] = 30
                    value[1]:ChangeDuration(30)
                    --ChatOutput("Return")
                    return
                 end
            end
        end

        table.insert( Timers,  {Counter(self, width, Settings.SPTimerHeight2, count, duration, message, Settings.SPNewFont, TimerColourNormal1, TimerColourNormal2, TimerColourNormal3, TimerColourNormal4, TimerColourNormal5, icon), duration, message, effectName, unique})
            --Timers[ID] =  {Counter(self, width, height, count, duration, message), duration, message}

        --ID = ID + 1
        self.ReOrder()
        --PrintTable(Timers)
    end

    self.Clear = function()
        for key, value in pairs(Timers) do 
            Timers[key] = nil
            table.remove(Timers, key )
            --PrintTable(Timers)
            value[1]:Destroy()
        end
    end

    self.ReOrder = function()
        if Tablelength(Timers) > 1 then  
            table.sort(Timers, Compare)
        end
        local counter = 0
        --ChatOutput("Reorder")
        for key, value in pairs(Timers) do
            --ChatOutput(value[2])
            value[1]:SetPosition(0, counter * Settings.SPTimerHeight2)
            counter = counter + 1
        end
    
        if Tablelength(Timers) > 0 then
            --self.Clear()
        end
    
        --PrintTable(Timers)
    end
    
    self.ResortList = function()
        --ChatOutput("Resort")
        local counter = 0
        for key, value in pairs(Timers) do
            value[1]:SetPosition(0, counter * Settings.SPTimerHeight2) 
            counter = counter + 1
        end
    end
end

function Tablelength(T)
    local count = 0
    if T ~= nil then
        for _ in pairs(T) do count = count + 1 end
    end
    return count
end


function Compare(a, b)
    --ChatOutput(a[3]..b[3])
    if a[2] ~= nil and b[2] ~= nil then
        return a[2] < b[2]
    end
end


function Round(num, numDecimalPlaces)
    local mult = 10^(numDecimalPlaces or 0)
    local number = math.floor(num * mult + 0.5) / mult
    if (number % 1) == 0 and numDecimalPlaces ~= 0 then
      return tostring(number .. ".0")
    else
      return number
    end
end



--Counters

Counter = class(Turbine.UI.Control)
function Counter:Constructor(parent, width, height, elements, duration, message, font, colour1, colour2, colour3, colour4, colour5, icon)

    --ChatOutput(message)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width, height)
    self:SetPosition(0, elements * height)
    self:SetOpacity(1)
    self:SetVisible(true)
    self:SetMouseVisible(false)
    local oldGameTime = Turbine.Engine.GetGameTime()

    local offset = 0

    if icon ~= nil then
        offset = 32
    end

    self.opacityWindow = Turbine.UI.Window()
    self.opacityWindow:SetParent(self)
    self.opacityWindow:SetVisible(true)
    self.opacityWindow:SetPosition(0, 0)
    self.opacityWindow:SetSize(width, height)
    self.opacityWindow:SetOpacity(0.4)

    self.outLine = Turbine.UI.Label()
    self.outLine:SetParent(self.opacityWindow)
    self.outLine:SetSize(width, height)
    self.outLine:SetMouseVisible(false)
    self.outLine:SetVisible(true)
    self.outLine:SetBackColor(Turbine.UI.Color(0,0,0))
    
    self.backLabel = Turbine.UI.Label()
    self.backLabel:SetParent(self.opacityWindow)
    self.backLabel:SetSize(width - 2 - offset, height - 2)
    self.backLabel:SetPosition(1 + offset,1)
    self.backLabel:SetMouseVisible(false)
    self.backLabel:SetVisible(true)

    self.frontLabel = Turbine.UI.Label()
    self.frontLabel:SetParent(self.opacityWindow)
    self.frontLabel:SetPosition(1 + offset,1)
    self.frontLabel:SetSize(width - 2 - offset, height - 2)
    self.frontLabel:SetBackColor(colour5)

    self.opacityWindow2 = Turbine.UI.Window()
    self.opacityWindow2:SetParent(self)
    self.opacityWindow2:SetVisible(true)
    self.opacityWindow2:SetPosition(0, 0)
    self.opacityWindow2:SetSize(width, height)
    --self.opacityWindow:SetOpacity(0.5)

    if icon ~= nil then
        self.iconLabel = Turbine.UI.Label()
        self.iconLabel:SetParent(self.opacityWindow2)
        self.iconLabel:SetPosition(1,1)
        self.iconLabel:SetSize(32, 32)
        self.iconLabel:SetMouseVisible(false)
        self.iconLabel:SetVisible(true)
        self.iconLabel:SetBackground(icon)
    end

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self.opacityWindow2)
    self.textLabel:SetPosition(1 + offset + 5, 1)
    self.textLabel:SetSize(width, height)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetVisible(true)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.textLabel:SetFont(font)
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetText(message.." "..duration)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetOutlineColor(OutlineColor)
    self.textLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )

    local s = message
    local number = duration
    local maxNumber = duration

    self.Destroy = function()
        self:SetVisible(false)
        self:SetWantsUpdates(false)
    end

    self.UpdateText = function()
        local currentGameTime = Turbine.Engine.GetGameTime()
        local delta = currentGameTime - oldGameTime
        number = number - delta
        if number <= 5 then
            self.textLabel:SetText(s.." ".. Round(number, 1))
        else 
            self.textLabel:SetText(s.." ".. math.floor(number))
        end
        self:UpdateColour()
        oldGameTime = currentGameTime
    end

    self.UpdateColour = function()
        if number == 0 then
            self.backLabel:SetBackColor(colour1)
        elseif number <= 5 then
            self.backLabel:SetBackColor(colour2)
        elseif number <= 10 then
            --self.backLabel:SetBackColor(colour3)
        else
            self.backLabel:SetBackColor(colour4)
        end
        self.frontLabel:SetSize(number / duration * (width - 2 - offset), (height - 2))
    end

    self:UpdateColour()

    self.GetRemainingTime = function()
        return(number)
    end

    self.GetDuration = function()
        return(maxNumber)
    end

    self.ChangeDuration = function(x, newNumber)
        --ChatOutput(newNumber)
        number = newNumber
    end
    --ChatOutput(message .. elements)
end

