BuffTracker = class(Turbine.UI.Window)
function BuffTracker:Constructor(Configuration)
    Turbine.UI.Window.Constructor(self);
    self.Config = Configuration
    self.width = Settings.TWidth
    local height = 200
    local x = self.Config.X
    local y = self.Config.Y

    local cooldownTimer = 0
    self.Timers = {}

    self.TimerHeight = 20

    self.ResortTimers = false

    self.itemCount = 0

    --self.TargetEffects.self = nil 

    self:SetSize(self.width, height);
    self:SetPosition(x,y);
    self:SetVisible(true)
    self:SetWantsUpdates(true)
    --Updater:Subscribe(self)
    self:SetMouseVisible(false)
    self:SetOpacity(1)
    --self:SetBackColor(GoldColor)
    self.colour = nil

    if self.Config.Buff then
        self.colour = TimerColourNormal5
    else
        self.colour = TimerColourNormal2
    end

    if self.Config.SortMethod == nil then self.Config.SortMethod = 1 end

    local SortingMethod = self.Config.SortMethod

    self.TimerContainer = Turbine.UI.Control()
    self.TimerContainer:SetParent(self)
    self.TimerContainer:SetVisible(true)
    self.TimerContainer:SetSize(100, height)
    self.TimerContainer:SetPosition(0, 0)
    self.TimerContainer:SetMouseVisible(false)

    local moveBox = MoveBox(self, self.width, 200, self.Config.Name)
    
    self.ToggleMove = function()
        BuffWindows[self.Config.Name].X = self:GetLeft()
        BuffWindows[self.Config.Name].Y = self:GetTop()
        moveBox:ToggleMove()
    end

    local effectList = Player:GetEffects()

    self.SetupTimers = function()
        for i = 1, effectList:GetCount(), 1 do
            self:NewTimer(effectList:Get(i))
        end 
    end

    self.Clear = function()
        for key, value in pairs(self.Timers) do 
            value[1]:Destroy()
            self.Timers[key] = nil
            --table.remove(self.Timers, key )
            --PrintTable(self.Timers)
        end
        if Tablelength(self.Timers) > 0 then
            self.Clear()
        end
        self.Timers = nil
        collectgarbage()
        self.Timers = {}
        self.itemCount = 0
    end

    self.ResortList = function()
        local counter = 0

        if SortingMethod == 1 then
            for _,v in spairs(self.Timers, function(t,a,b) return t[b][2] < t[a][2] end) do
                v[1]:SetPosition(0, counter * self.TimerHeight) 
                counter = counter + 1
            end
        elseif SortingMethod == 2 then
            for _,v in spairs(self.Timers, function(t,a,b) return t[b][2] > t[a][2] end) do
                v[1]:SetPosition(0, counter * self.TimerHeight) 
                counter = counter + 1
            end
        end

        self.ResortTimers = false
    end
    self.SetupTimers()
end

function BuffTracker:Reset()
    self.Clear()
    self.SetupTimers()
end

function BuffTracker:RemoveTimer(id)
    if self.Timers[id] ~= nil then 
        self.Timers[id][1]:Destroy()
        self.Timers[id] = nil
        self.itemCount = self.itemCount - 1
        self.ResortTimers = true
    end
end

-- Add a timer
function BuffTracker:NewTimer(effect)
    if self.Config.Buff and effect:IsDebuff() or not(self.Config.Buff) and not(effect:IsDebuff()) then return end
    if self.Config.Mode == 1 and not(self.Config.List[effect:GetName()]) or self.Config.Mode == 2 and self.Config.List[effect:GetName()] then return end
    local maxDuration = effect:GetDuration()
    local duration = effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime())

    self.Timers[effect:GetID()] = {Counter2(self.TimerContainer, self.width, self.TimerHeight, self.itemCount, maxDuration, effect:GetName(), Settings.SPNewFont, TimerColourNormal1, nil, TimerColourNormal3, TimerColourNormal4, self.colour, effect:GetIcon(), effect, self.Config.Name, self), duration}
    self.itemCount = self.itemCount + 1

    Updater:Subscribe(self) 

    self.ResortTimers = true

    maxDuration = nil
    duration = nil
    effect = nil
end

function BuffTracker:ExecuteUpdate(delta)   
    --We had an update
    for key, value in pairs(self.Timers) do 
        value[2] = value[2] - delta
        value[1]:UpdateText(delta)
        if value[2] < 0 then 
            --PrintTable(self.Timers)
            --ChatOutput("Delete ID: " .. key)
            value[1]:Destroy()
            self.Timers[key] = nil
            --PrintTable(self.Timers)
            self.ResortTimers = true
            self.itemCount = self.itemCount - 1
        end
    end

    if self.ResortTimers then 
        if self.itemCount == 0 then 
            Updater:UnSubscribe(self) 
            self.Timers = nil
            collectgarbage()
            self.Timers = {}
            return
        end
        self.ResortList() 
    end
end


