BuffTrackerSettings = class(Turbine.UI.Control)
function BuffTrackerSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    local colorTurn = 0
    local prevItem = nil
    local prevColour = nil
    local selectedName = nil
    local selfWindowSelected = true

    local SettingsWindows = {}

    local BuffWindowContainerItems = {}

    self.CreateBuffwindowItem = function(name)
        local listItem = Turbine.UI.Control();
        listItem:SetVisible(true)
        listItem:SetSize( 200, 20 );
        listItem:SetMouseVisible(true)
        listItem:SetBackColor(Turbine.UI.Color.Gray)

        --    ["Immolated"] = {3, Wounds, CureIcon, false, SoundEffects["Beepq"]},
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 20)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetForeColor(Turbine.UI.Color(0,0,0))
        NameLabel:SetMarkupEnabled(true)
        NameLabel:SetText(name)

        listItem.MouseClick = function()
            if prevItem ~= nil then
                prevItem:SetBackColor(Turbine.UI.Color.Gray)
            end
            prevItem = listItem
            listItem:SetBackColor(Turbine.UI.Color.LightGray)
            selectedName = name
            for key, value in pairs(SettingsWindows) do
                value:SetVisible(false)
                --ChatOutput(key)
            end
            --ChatOutput(name)
            SettingsWindows[name]:SetVisible(true)
        end

        return(listItem)
    end

    self.MakeEffectListItem = function(box, Name, text, print)
        local listItem = Turbine.UI.Control();
        listItem:SetVisible(true)
        listItem:SetSize( 200, 20 );
        listItem:SetMouseVisible(true)

        if print then ChatOutput("Added Effect: " .. text .. " To Buff Window: " .. Name) end

        BuffWindows[Name].List[text] = true
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 20)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetForeColor(Turbine.UI.Color(0,0,0))
        NameLabel:SetMarkupEnabled(true)
        NameLabel:SetText(text)

        listItem.MouseClick = function()
            BuffWindows[Name].List[text] = nil
            ChatOutput("Removed Effect: " .. text .. " To Buff Window: " .. Name)
            box:RemoveItem(listItem)
        end

        box:AddItem(listItem)
    end

    self.MakeWindowSettingsWindow = function(Name)
        local WindowControl = Turbine.UI.Control()
        WindowControl:SetParent(self)
        WindowControl:SetSize(500, 600)
        WindowControl:SetPosition(300, 60)
        WindowControl:SetVisible(false)

        -- Info label
        local InfoLabel = Turbine.UI.Label()
        InfoLabel:SetParent(WindowControl)
        InfoLabel:SetSize(200, 40)
        InfoLabel:SetPosition(0, 200)
        InfoLabel:SetText("For some changes you need to reload the plugin")

        -- Buff/Debuff button
        local Button1 = Turbine.UI.Lotro.Button()
        Button1:SetParent(WindowControl)
        Button1:SetSize(100, 15)
        Button1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button1:SetMouseVisible(true)
        Button1:SetPosition(0, 0)

        if BuffWindows[Name].Buff then
            Button1:SetText("Buffs")
        else
            Button1:SetText("Debuffs")
        end
    
        Button1.Click = function()
            if Button1:GetText() == "Buffs" then
                Button1:SetText("Debuffs")
                BuffWindows[Name].Buff = false
            else
                Button1:SetText("Buffs")
                BuffWindows[Name].Buff = true
            end
        end

        -- Mode button
        local Button2 = Turbine.UI.Lotro.Button()
        Button2:SetParent(WindowControl)
        Button2:SetSize(100, 15)
        Button2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button2:SetMouseVisible(true)
        Button2:SetPosition(0, 30)
        if BuffWindows[Name].Mode == 0 then
            Button2:SetText("No Filter")
        elseif BuffWindows[Name].Mode == 1 then
            Button2:SetText("WhiteList")
        elseif BuffWindows[Name].Mode == 2 then
            Button2:SetText("BlackList")
        end
    
        Button2.Click = function()
            if Button2:GetText() == "No Filter" then
                Button2:SetText("WhiteList")
                BuffWindows[Name].Mode = 1
            elseif Button2:GetText() == "WhiteList" then
                Button2:SetText("BlackList")
                BuffWindows[Name].Mode = 2
            elseif Button2:GetText() == "BlackList" then
                Button2:SetText("No Filter")
                BuffWindows[Name].Mode = 0
            end
        end

        -- Effect list
        local ItemTextBox = Turbine.UI.Lotro.TextBox()
        ItemTextBox:SetParent(WindowControl)
        ItemTextBox:SetSize(150, 30)
        ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemTextBox:SetMouseVisible(false)
        ItemTextBox:SetPosition(0, 60)
        ItemTextBox:SetMultiline(false)
        ItemTextBox:SetText("<Effect>")

        local lab = Turbine.UI.Label()
        lab:SetParent(WindowControl)
        lab:SetSize(250, 20)
        lab:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        lab:SetMouseVisible(false)
        lab:SetPosition(200, 0)
        lab:SetMultiline(false)
        lab:SetText("Click on an effect to remove it")

        local container = Turbine.UI.ListBox()
        container:SetParent(WindowControl)
        container:SetSize(200, height - 200)
        container:SetPosition(200, 20)
        --container:SetBackColor(GoldColor)
        container:SetVisible(true)
        container:SetWantsKeyEvents(true)
        container:SetMouseVisible(true)
    
        local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
        containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
        containerScrollbar:SetParent( WindowControl );
        containerScrollbar:SetPosition(430 - 10, 20 );
        containerScrollbar:SetSize( 10, height - 200 );
        container:SetVerticalScrollBar( containerScrollbar );

        local sortedKeys = {}
        for key, value in pairs(BuffWindows[Name].List) do table.insert( sortedKeys, key ) end
        table.sort( sortedKeys )
    
        for key, value in pairs(sortedKeys) do
            self.MakeEffectListItem(container, Name, value, false)
        end

        local Button3 = Turbine.UI.Lotro.Button()
        Button3:SetParent(WindowControl)
        Button3:SetSize(100, 15)
        Button3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button3:SetMouseVisible(true)
        Button3:SetPosition(0, 95)
        Button3:SetText("Add Effect")
    
        Button3.Click = function()
            self.MakeEffectListItem(container, Name, ItemTextBox:GetText(), true)
        end

        local Button4 = Turbine.UI.Lotro.Button()
        Button4:SetParent(WindowControl)
        Button4:SetSize(150, 15)
        Button4:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button4:SetMouseVisible(true)
        Button4:SetPosition(0, 125)
        if BuffWindows[Name].SortMethod == nil then
            BuffWindows[Name].SortMethod = 1
        end

        if BuffWindows[Name].SortMethod == 1 then
            Button4:SetText("Highest on Top")
        elseif  BuffWindows[Name].SortMethod == 2 then
            Button4:SetText("Lowest on Top")
        end
    
        Button4.Click = function()
            if Button4:GetText() == "Highest on Top" then
                Button4:SetText("Lowest on Top")
                BuffWindows[Name].SortMethod = 2
            else
                Button4:SetText("Highest on Top")
                BuffWindows[Name].SortMethod = 1
            end 
        end


        local Button4 = Turbine.UI.Lotro.Button()
        Button4:SetParent(WindowControl)
        Button4:SetSize(100, 15)
        Button4:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button4:SetMouseVisible(true)
        Button4:SetPosition(0, 160)
        Button4:SetText("Delete window")

            
        Button4.Click = function()
            BuffWindowContainerItems[Name]:SetVisible(false)

            --container:RemoveItem(item)
            BuffWindowObjects[Name]:SetVisible(false)
            BuffWindowObjects[Name]:SetParent(nil)
            BuffWindowObjects[Name] = nil
            BuffWindows[Name]= nil
            WindowControl:SetVisible(false)

            ChatOutput("Deleted Buff Window: " .. Name)
        end


        SettingsWindows[Name] = WindowControl

    end

    self.NewWindowSettings = function()
        
    end

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(30 - 2, 50 - 2)
    SingleBackground:SetSize(200 + 4, height - 200 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(30, 50)
    SingleBackground:SetSize(200, height - 200)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local container = Turbine.UI.ListBox()
    container:SetParent(self)
    container:SetSize(200, height - 200)
    container:SetPosition(30, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    containerScrollbar:SetParent( self );
    containerScrollbar:SetPosition(230 - 10, 50 );
    containerScrollbar:SetSize( 10, height - 200 );
    container:SetVerticalScrollBar( containerScrollbar );

    local sortedKeys = {}
    for key, value in pairs(BuffWindows) do table.insert( sortedKeys, key ) end
    table.sort( sortedKeys )

    for key, value in pairs(sortedKeys) do
        self.MakeWindowSettingsWindow(value)
        local TempItem = self.CreateBuffwindowItem(value)
        BuffWindowContainerItems[value] = TempItem
        container:AddItem(TempItem)
    end

    local ItemTextBox = Turbine.UI.Lotro.TextBox()
    ItemTextBox:SetParent(self)
    ItemTextBox:SetSize(150, 30)
    ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox:SetMouseVisible(false)
    ItemTextBox:SetPosition(30, 10)
    ItemTextBox:SetMultiline(false)
    ItemTextBox:SetText("<Name>")

    local AddButton = Turbine.UI.Lotro.Button()
    AddButton:SetParent(self)
    AddButton:SetSize(100, 15)
    AddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    AddButton:SetMouseVisible(true)
    AddButton:SetPosition(190, 15)
    AddButton:SetText("Add window")

    AddButton.Click = function()
        if BuffWindows[ItemTextBox:GetText()] ~= nil then 
            ChatOutput("Already existing window")
            return
        end
        local Config = {}
        Config.Buff = true
        Config.List = {}
        Config.Name = ItemTextBox:GetText()
        Config.Mode = 0 -- 0 -> no filter | 1 --> whitelist | 2 --> blacklist
        Config.X = math.floor(Turbine.UI.Display.GetWidth() / 2 - (Settings.SNewWidth/2))
        Config.Y = math.floor(Turbine.UI.Display.GetHeight() / 1.5)
        BuffWindows[ItemTextBox:GetText()] = Config
        self.MakeWindowSettingsWindow(ItemTextBox:GetText())
        local TempItem = self.CreateBuffwindowItem(ItemTextBox:GetText())
        BuffWindowContainerItems[ItemTextBox:GetText()] = TempItem
        container:AddItem(TempItem)
    end

end