-- Normal timer
Counter = class(Turbine.UI.Control)
function Counter:Constructor(parent, width, height, elements, duration, message, font, colour1, colour2, colour3, colour4, colour5, icon)

    --ChatOutput(message)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width, height)
    self:SetPosition(0, elements * height)
    self:SetOpacity(1)
    self:SetVisible(true)
    self:SetMouseVisible(false)

    local offset = 0

    if icon ~= nil then
        offset = 32
    end

    local opacityWindow = Turbine.UI.Window()
    opacityWindow:SetParent(self)
    opacityWindow:SetVisible(true)
    opacityWindow:SetPosition(0, 0)
    opacityWindow:SetSize(width, height)
    opacityWindow:SetOpacity(0.4)
    opacityWindow:SetMouseVisible(false)

    local outLine = Turbine.UI.Label()
    outLine:SetParent(opacityWindow)
    outLine:SetSize(width, height)
    outLine:SetMouseVisible(false)
    outLine:SetVisible(true)
    outLine:SetBackColor(Turbine.UI.Color(0,0,0))
    outLine:SetMouseVisible(false)
    
    local backLabel = Turbine.UI.Label()
    backLabel:SetParent(opacityWindow)
    backLabel:SetSize(width - 2 - offset, height - 2)
    backLabel:SetPosition(1 + offset,1)
    backLabel:SetMouseVisible(false)
    backLabel:SetVisible(true)
    backLabel:SetMouseVisible(false)

    local frontLabel = Turbine.UI.Label()
    frontLabel:SetParent(opacityWindow)
    frontLabel:SetPosition(1 + offset,1)
    frontLabel:SetSize(width - 2 - offset, height - 2)
    frontLabel:SetBackColor(colour5)
    frontLabel:SetMouseVisible(false)

    local opacityWindow2 = Turbine.UI.Window()
    opacityWindow2:SetParent(self)
    opacityWindow2:SetVisible(true)
    opacityWindow2:SetPosition(0, 0)
    opacityWindow2:SetSize(width, height)
    --self.opacityWindow:SetOpacity(0.5)
    opacityWindow2:SetMouseVisible(false)

    if icon ~= nil then
        local iconLabel = Turbine.UI.Label()
        iconLabel:SetParent(opacityWindow2)
        iconLabel:SetPosition(1,1)
        iconLabel:SetSize(32, 32)
        iconLabel:SetMouseVisible(false)
        iconLabel:SetVisible(true)
        iconLabel:SetBackground(icon)
        iconLabel:SetMouseVisible(false)
    end

    local durationVisible = true
    if duration > 99999 then
        durationVisible = false
    end

    local textLabel = Turbine.UI.Label()
    textLabel:SetParent(opacityWindow2)
    textLabel:SetPosition(1 + offset + 5, 1)
    textLabel:SetSize(width - 65, height)
    textLabel:SetMouseVisible(false)
    textLabel:SetVisible(true)
    textLabel:SetMultiline(false)
    textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    textLabel:SetFont(font)
    textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    textLabel:SetMouseVisible(false)
    textLabel:SetText(message)
    textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    textLabel:SetOutlineColor(OutlineColor)
    textLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
    textLabel:SetMouseVisible(false)

    self.durationLabel = Turbine.UI.Label()
    self.durationLabel:SetParent(opacityWindow2)
    self.durationLabel:SetPosition(width - 25, 1)
    self.durationLabel:SetSize(25, height)
    self.durationLabel:SetFont(font)
    self.durationLabel:SetVisible(durationVisible)
    self.durationLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.durationLabel:SetMouseVisible(false)
    self.durationLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.durationLabel:SetOutlineColor(OutlineColor)
    self.durationLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.durationLabel:SetMultiline(false)
    self.durationLabel:SetText(duration)
    self.durationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.durationLabel:SetMouseVisible(false)

    local s = message
    self.number = duration
    local maxNumber = duration

    self.Destroy = function()
        self:SetVisible(false)
        offset = nil
        opacityWindow = nil
        outLine = nil
        backLabel = nil
        frontLabel = nil
        opacityWindow2 = nil
        iconLabel = nil
        durationVisible = nil
        textLabel = nil
        self.durationLabel = nil

        self:SetParent(nil)
        self = nil
    end

    self.UpdateColour = function()
        if self.number == 0 then
            backLabel:SetBackColor(colour1)
        elseif self.number <= 5 then
            backLabel:SetBackColor(colour2)
        elseif self.number <= 10 then
            --self.backLabel:SetBackColor(colour3)
        else
            backLabel:SetBackColor(colour4)
        end
        frontLabel:SetSize(self.number / duration * (width - 2 - offset), (height - 2))
    end

    self:UpdateColour()

    self.GetRemainingTime = function()
        return(self.number)
    end

    self.GetDuration = function()
        return(maxNumber)
    end
    --ChatOutput(message .. elements)
end

function Counter:UpdateText(delta)
    self.number = self.number - delta
    if self.number <= 5 then
        self.durationLabel:SetText(Round(self.number, 1))
    else 
        self.durationLabel:SetText(math.floor(self.number))
    end
    self:UpdateColour()
end

function Counter:ChangeDuration(newNumber)
    --ChatOutput(newNumber)
    self.number = newNumber
end

-- Timer based on effect display
Counter2 = class(Turbine.UI.Control)
function Counter2:Constructor(parent, width, height, elements, duration, message, font, colour1, colour2, colour3, colour4, colour5, icon, effect, options, buffWindow, reset)

    --ChatOutput(effect:GetName())
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width, height)
    self:SetPosition(0, elements * height)
    self:SetOpacity(1)
    self:SetVisible(true)
    self:SetMouseVisible(false)

    local offset = 0
    local effectName = nil

    if effect ~= nil then
        offset = height
        effectName = effect:GetName()
    end

    local opacityWindow = Turbine.UI.Window()
    opacityWindow:SetParent(self)
    opacityWindow:SetVisible(true)
    opacityWindow:SetPosition(0, 0)
    opacityWindow:SetMouseVisible(false)
    opacityWindow:SetSize(width, height)
    opacityWindow:SetOpacity(0.4)

    local outLine = Turbine.UI.Label()
    outLine:SetParent(opacityWindow)
    outLine:SetSize(width, height)
    outLine:SetMouseVisible(false)
    outLine:SetVisible(true)
    outLine:SetBackColor(Turbine.UI.Color(0,0,0))
    
    local backLabel = Turbine.UI.Label()
    backLabel:SetParent(opacityWindow)
    backLabel:SetSize(width - 2 - offset, height - 2)
    backLabel:SetPosition(1 + offset,1)
    backLabel:SetMouseVisible(false)
    backLabel:SetVisible(true)

    local frontLabel = Turbine.UI.Label()
    frontLabel:SetParent(opacityWindow)
    frontLabel:SetPosition(1 + offset,1)
    frontLabel:SetSize(width - 2 - offset, height - 2)
    frontLabel:SetBackColor(colour5)
    frontLabel:SetMouseVisible(false)

    local opacityWindow2 = Turbine.UI.Window()
    opacityWindow2:SetParent(self)
    opacityWindow2:SetVisible(true)
    opacityWindow2:SetPosition(0, 0)
    opacityWindow2:SetSize(width, height)
    opacityWindow2:SetMouseVisible(false)
    --self.opacityWindow:SetOpacity(0.5)

    if effect ~= nil then
        local iconLabel = Turbine.UI.Lotro.EffectDisplay()
        iconLabel:SetEffect(effect)
        iconLabel:SetParent(opacityWindow2)
        --iconLabel:SetPosition(1,1)
        iconLabel:SetSize(height, height)
        iconLabel:SetMouseVisible(false)
        iconLabel:SetVisible(true)
        --self.iconLabel:SetBackground(icon)
    end

    local durationVisible = true
    if duration > 99999 then
        durationVisible = false
        backLabel:SetBackColor(colour5)
    end

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(opacityWindow2)
    self.textLabel:SetPosition(1 + offset + 5, 1)
    self.textLabel:SetSize(width - 45, height)
    self.textLabel:SetVisible(true)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.textLabel:SetFont(font)
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetText(message)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetOutlineColor(OutlineColor)
    self.textLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.textLabel:SetMultiline(false)

    self.durationLabel = Turbine.UI.Label()
    self.durationLabel:SetParent(opacityWindow2)
    self.durationLabel:SetPosition(width - 28, 1)
    self.durationLabel:SetSize(25, 20)
    self.durationLabel:SetFont(font)
    self.durationLabel:SetVisible(durationVisible)
    self.durationLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.durationLabel:SetMouseVisible(false)
    self.durationLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.durationLabel:SetOutlineColor(OutlineColor)
    self.durationLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.durationLabel:SetMultiline(false)
    self.durationLabel:SetText(duration)
    self.durationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    --self.durationLabel:SetBackColor(OutlineColor)
    --self.self.durationLabel:
    

    local s = message
    self.number = duration
    if effect ~= nil then
        if reset == 1 then
            self.number = effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime())
        elseif reset == 2 then
            self.number = duration - (Turbine.Engine.GetGameTime() - effect:GetStartTime())
        end
    end
    local maxNumber = duration
    local colourEvent = 5
    self.oldnumber = duration
    if colour2 == nil then colourEvent = -1 end

    self.Destroy = function()
        self:SetVisible(false)
        offset = nil
        opacityWindow = nil
        outLine = nil
        backLabel = nil
        frontLabel = nil
        opacityWindow2 = nil
        iconLabel = nil
        durationVisible = nil
        self.textLabel = nil
        self.durationLabel = nil

        self:SetParent(nil)
        self = nil
    end

    self.UpdateColour = function()
        if self.number <= colourEvent then
            if self.number == 0 then
                backLabel:SetBackColor(colour1)
                colourEvent = -5
            elseif self.number <= 5 then
                backLabel:SetBackColor(colour2)
                colourEvent = 0
            elseif self.number <= 10 then
                --self.backLabel:SetBackColor(colour3)
            else
                backLabel:SetBackColor(colour4)
            end
        end
        frontLabel:SetSize(self.number / duration * (width - 2 - offset), (height - 2))
    end

    self:UpdateColour()

    self.GetRemainingTime = function()
        return(self.numbe)
    end

    self.GetDuration = function()
        return(maxNumber)
    end

    --ChatOutput(message .. elements)

    if options ~= nil then
        local clickWindow = Turbine.UI.Window()
        clickWindow:SetParent(self)
        clickWindow:SetVisible(true)
        clickWindow:SetPosition(0, 0)
        clickWindow:SetMouseVisible(true)
        clickWindow:SetSize(width - height, height)
        clickWindow:SetPosition(height, 0)

        local menu = Turbine.UI.ContextMenu()
        local menuItems = menu:GetItems()

        local item = Turbine.UI.MenuItem( "Add to Filter" )
        menuItems:Add(item)
        item.Click = function(sender, args)
            --ChatOutput(options)
            --ChatOutput(effectName)
            BuffWindows[options].List[effectName] = true
            buffWindow:Reset()
        end

        clickWindow.MouseClick = function()
            menu:ShowMenu()
        end
    end

    effect = nil
end

function Counter2:ChangeDuration(newNumber)
    --ChatOutput(newNumber)
    self.number = newNumber
    self.oldnumber = newNumber
end

function Counter2:UpdateText(delta)
    if self.number > 99999 then return end
    self.number = self.number - delta
    if self.oldnumber - self.number > 0.05 then
        if self.number <= 5 then
            self.durationLabel:SetText(Round(self.number, 1))
        else 
            self.durationLabel:SetText(math.floor(self.number))
        end
        self:UpdateColour()
        self.oldnumber = self.number
    end
end

function Counter2:ChangeName(newName)
    self.textLabel:SetText(newName)
end