function InitiateHandlers()
    Player.InCombatChanged = function(sender, arg)

        if combatTimer ~= nil then combatTimer:CombatChanged() end
    
        if Target ~= nil then Target:CombatUpdate() end
        
    end

    Player.TargetChanged = function()

        if Target ~= nil then Target:TargetChanged() end

        if targetBox then targetBox:TargetChanged() end
        
    end
end

UpdateHandler = class(Turbine.UI.Control)
function UpdateHandler:Constructor()
    Turbine.UI.Control.Constructor(self);
    self:SetWantsUpdates(true)

    local oldGameTime = Turbine.Engine.GetGameTime()

    self.UpdateList = {}

    self.Update = function()
        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == oldGameTime then
            return(true)
        end
        local delta = currentGameTime - oldGameTime

        --ChatOutput(collectgarbage("count")*1024)
        --ChatOutput(collectgarbage("count")*1024)

        for key, value in pairs(self.UpdateList) do
            key:ExecuteUpdate(delta)
        end

        oldGameTime = currentGameTime
    end
end

function UpdateHandler:Subscribe(object)
    self.UpdateList[object] = true
end

function UpdateHandler:UnSubscribe(object)
    self.UpdateList[object] = nil
end

GarbageHandler = class(Turbine.UI.Control)
function GarbageHandler:Constructor()
    Turbine.UI.Control.Constructor(self);

    local UpdateInterval = 30
    self.UpdateTime = UpdateInterval

    Updater:Subscribe(self)

    self.ScheduleClear = function()
        self.UpdateTime = 5
        Updater:Subscribe(self)
    end

    self.UnScheduleClear = function()
        Updater:UnSubscribe(self)
    end

    self.ExecuteGC = function()
        
        --ChatOutput("Pre Clear: " .. collectgarbage("count")*1024)

        -- Reset group data
        --RefreshGroupData()

        -- Reset target data
        if Target ~= nil then Target:RefreshData() end

        -- Reset timer
        self.UpdateTime = UpdateInterval

        --ChatOutput("Post Clear: " .. collectgarbage("count")*1024)
    end
end

function GarbageHandler:ExecuteUpdate(delta)
    self.UpdateTime = self.UpdateTime - delta

    if self.UpdateTime < 0 then self.ExecuteGC() end
end


function HandleBuffWindows()
    BuffWindows = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeBuffWindows")
    
    BuffWindowObjects = {}

    if BuffWindows == nil then
        BuffWindows = {}
        return 
    end

    for key, value in pairs(BuffWindows) do
        local buff = BuffTracker(value)
        BuffWindowObjects[key] = buff
    end
end