ReadyWindow = class(Turbine.UI.Lotro.Window)
function ReadyWindow:Constructor()
    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(32, 32)
    --self:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self:SetVisible(false)
    self:SetPosition(math.floor( Turbine.UI.Display.GetWidth() / 2 - 400), math.floor( Turbine.UI.Display.GetHeight() / 2 - 200))
    self:SetMouseVisible(true)
    self:SetWantsKeyEvents(true)
    self:SetText("ReadyCheck")
    --self:SetWantsUpdates(false)

    self.KeyDown = function(sender, args)
        if args["Action"] == 145 then
            if self:IsVisible() then self:SetVisible(false) end
        end
    end

    local PartyMembers = {}
    local CurrentReadyCheckTimer = 0
    local oldGameTime = Turbine.Engine.GetGameTime()
    local TimeSinceLastUpdate = 0
    local rcActive = false

    -- Construct the window for the new readyCheck
    self.MakeNewReadyCheck = function()
        self.CleanUp()
        for i = 1, Party:GetMemberCount(), 1 do
            local p = Party:GetMember(i)
            PartyMembers[p:GetName()] = ReadyLabel2(p, self, i)

        end
        CurrentReadyCheckTimer = Turbine.Engine.GetGameTime()
        rcActive = true
        --self:SetSize(40 * 6 + 0, 80 * Party:GetMemberCount() + 80 + 40)
        self:SetSize(200, 30 * Party:GetMemberCount() + 60)
        self:SetPosition(math.floor( Turbine.UI.Display.GetWidth() / 2 - self:GetWidth() / 2), math.floor( Turbine.UI.Display.GetHeight() / 2 - self:GetHeight() / 2))
    end

    -- We got an update from a partymember handle it
    self.UpdateReadycheckMember = function(sender, p, r)
        if PartyMembers[p] ~= nil then 
            PartyMembers[p]:UpdateReadyState(r)
        end
    end

    self.CleanUp = function()
        for key, value in pairs(PartyMembers) do
            PartyMembers[key]:SetVisible(false)
            PartyMembers[key] = nil
        end
    end

    -- Clean up the window
    self.Closing = function()
        rcActive = false
        self.CleanUp()
    end

    self.ReadyCheckActive = function()
        return(rcActive)
    end

    self.UpdateBuffWindow = function(sender, player, effectName)
        if PartyMembers[player] ~= nil then
            PartyMembers[player]:ScropeState(effectName)
        end
    end

    --[[

    local offset = 20 + 5
    -- Make header
    self.icon = Turbine.UI.Label()
    self.icon:SetParent(self)
    self.icon:SetSize(50, 20)
    self.icon:SetPosition(10, 10 + offset + 5)
    self.icon:SetTextAlignment(Turbine.UI.ContentAlignment.Left)
    --self.icon:SetBackground(Icons[player:GetClass()])
    self.icon:SetMouseVisible(false)
    self.icon:SetText("Class")

    self.label = Turbine.UI.Label()
    self.label:SetParent(self)
    self.label:SetSize(100 - 32, 32)
    self.label:SetPosition(10, 32 + offset + 5)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.Left)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiqua18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetMouseVisible(false)
    self.label:SetVisible(true)
    self.label:SetOutlineColor(Turbine.UI.Color(0,0,0))
    --self.label:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.label:SetText("Name")
    self.label:SetForeColor(Turbine.UI.Color(1, 1, 1))

    self.scrollOffensiveLabel = Turbine.UI.Label()
    self.scrollOffensiveLabel:SetParent(self)
    self.scrollOffensiveLabel:SetSize(20, 20)
    self.scrollOffensiveLabel:SetPosition(10 + 6, 6+  64 + offset)
    self.scrollOffensiveLabel:SetMouseVisible(false)
    self.scrollOffensiveLabel:SetBackground(OScroll)

    self.scrollDefensiveLabel = Turbine.UI.Label()
    self.scrollDefensiveLabel:SetParent(self)
    self.scrollDefensiveLabel:SetSize(20, 20)
    self.scrollDefensiveLabel:SetPosition(10 + 6, 6 + 96 + offset)
    self.scrollDefensiveLabel:SetMouseVisible(false)
    self.scrollDefensiveLabel:SetBackground(DScroll)

    self.hopeLabel = Turbine.UI.Label()
    self.hopeLabel:SetParent(self)
    self.hopeLabel:SetSize(20, 20)
    self.hopeLabel:SetPosition(10 + 6,128 + 6 + offset)
    self.hopeLabel:SetMouseVisible(false)
    self.hopeLabel:SetBackground(Hope)

    self.dbLabel = Turbine.UI.Label()
    self.dbLabel:SetParent(self)
    self.dbLabel:SetSize(20, 20)
    self.dbLabel:SetPosition(10 + 6, 6 + 160 + offset)
    self.dbLabel:SetMouseVisible(false)
    self.dbLabel:SetBackground(DBIcon)
    --]]
end

ReadyCheckWindow = class(Turbine.UI.Window)
function ReadyCheckWindow:Constructor()
    Turbine.UI.Lotro.Window.Constructor(self);
    self.activeReadyCheck = false
    self.countdownTimer = 0 --
    local readyCheckStartTime = 0
    local oldGameTime = Turbine.Engine.GetGameTime()
    self.width = 400
    local height = 150
    self:SetSize(self.width,height);
    self:SetPosition( math.floor(Turbine.UI.Display.GetWidth() / 2 - (self.width/2)), math.floor(Turbine.UI.Display.GetHeight() / 2 - (height /2) - 2));
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetZOrder(1)
    --self:SetBackColor(Turbine.UI.Color(0, 0, 0))
    --self:SetWantsUpdates(false)
    self:SetText("Ready Check")
    self:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)    

    self.SetReady = function()
        --self:SetWantsUpdates(false)
        Updater:UnSubscribe(self)
        self:SetVisible(false)
    end

    self.timerBarShell = Turbine.UI.Label()
    self.timerBarShell:SetParent(self)
    self.timerBarShell:SetSize(self.width - 20 + 4, 10 + 4)
    self.timerBarShell:SetBackColor(Turbine.UI.Color(1, 1, 1))
    self.timerBarShell:SetPosition(10 - 2, 80 - 2)

    self.timerBar = Turbine.UI.Label()
    self.timerBar:SetParent(self)
    self.timerBar:SetSize(self.width - 20, 10)
    self.timerBar:SetBackColor(Turbine.UI.Color.DarkGreen)
    self.timerBar:SetPosition(10, 80)

    self.confirmLabel = Turbine.UI.Label()
    self.confirmLabel:SetVisible(true)
    self.confirmLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
    self.confirmLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.confirmLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.confirmLabel:SetText("ARE YOU READY?!")
    self.confirmLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.confirmLabel:SetParent(self)
    self.confirmLabel:SetSize(400, 40)
    self.confirmLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.confirmLabel:SetPosition(0, 40)

    self.readyButton = Turbine.UI.Lotro.Quickslot()
    self.readyButton:SetParent(self)
    self.readyButton:SetUseOnRightClick(false)
    self.readyButton:SetShortcut()
    self.readyButton:SetPosition(108, 108)
    self.readyButton:SetParent(self)
    self.readyButton:SetMouseVisible((true))
    self.readyButton:SetWantsKeyEvents(true)
    self.readyButton:SetSize(15, 18)

    self.readyCover = Turbine.UI.Label()
    self.readyCover:SetParent(self)
    self.readyCover:SetBackground(RCReady)
    self.readyCover:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.readyCover:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    self.readyCover:SetParent(self)
    self.readyCover:SetSize(24,32)
    self.readyCover:SetPosition(100, 100)
    self.readyCover:SetMouseVisible(false)
    --self.readyCover:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)

    self.ActionCheck = function()
        --self:SetWantsUpdates(false)
        Updater:UnSubscribe(self)
        self:SetVisible(false)
    end

    self.notReadyButton = Turbine.UI.Lotro.Quickslot()
    self.notReadyButton:SetParent(self)
    self.notReadyButton:SetUseOnRightClick(false)
    self.notReadyButton:SetShortcut()
    self.notReadyButton:SetPosition(281, 108)
    self.notReadyButton:SetParent(self)
    self.notReadyButton:SetSize(15, 15)

    self.notReadyCover = Turbine.UI.Label()
    self.notReadyCover:SetParent(self)
    self.notReadyCover:SetBackground(RCNotReady)
    self.notReadyCover:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.notReadyCover:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    self.notReadyCover:SetSize(24,32)
    self.notReadyCover:SetPosition(276, 100)
    self.notReadyCover:SetParent(self)
    self.notReadyCover:SetMouseVisible(false)
    --self.notReadyCover:SetBackColorBlendMode(Turbine.UI.BlendMode.None)

    self.notReadyButton.Click = function()
        self.ActionCheck()
    end

    self.MakeReadyCheck = function()
        oldGameTime = Turbine.Engine.GetGameTime()
        self.countdownTimer = 60
        self:SetVisible(true)
        --self:SetWantsUpdates(true)
        Updater:Subscribe(self)
        self.timerBar:SetSize(self.width - 20, 10)
        local channel = "f"
        if Party:GetMemberCount() > 6 then
            channel = "ra"
        end
        self.activeReadyCheck = true
        local readyShortcut = Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. channel .. " " .. Player:GetName() .. " Ready ")
        local notReadyShortcut = Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. channel .. " " .. Player:GetName() .. " Not Ready ")

        self.readyCover.MouseLeave=function(s,a)
            -- hack to prevent real item from being consumed by a click
            local sc = self.readyCover:GetShortcut();
            self.readyCover:SetShortcut(nil);
            self.readyCover:SetShortcut(readyShortcut);
        end	

        self.notReadyCover.MouseLeave=function(s,a)
            -- hack to prevent real item from being consumed by a click
            local sc = self.notReadyCover:GetShortcut();
            self.notReadyCover:SetShortcut(nil);
            self.notReadyCover:SetShortcut(notReadyShortcut);
        end	

        self.readyButton:SetShortcut(readyShortcut)
        self.notReadyButton:SetShortcut(notReadyShortcut)

    end

    self.OngoingReadycheck = function()
        return(self.activeReadyCheck)
    end
end


function ReadyCheckWindow:ExecuteUpdate(delta)
    self.countdownTimer = self.countdownTimer - delta

    if self.countdownTimer > 0 then
        self.timerBar:SetSize((self.width - 20) / (60/self.countdownTimer), 10)
    else
        --self:SetWantsUpdates(false)
        Updater:UnSubscribe(self)
        self:SetVisible(false)
        self.activeReadyCheck = false
    end
end

ReadyLabel = class(Turbine.UI.Control)
function ReadyLabel:Constructor(player, parent, index)
    Turbine.UI.Control.Constructor(self);
    self:SetParent(parent)
    self:SetVisible(true)
    self:SetSize(80, 300)
    self:SetPosition(80 * index, 20 + 5)
    --self:SetBackColor(Turbine.UI.Color( math.random(), math.random(), math.random() ) )
    self:SetMouseVisible(false)
    --self:SetWantsUpdates(true)

    self.icon = Turbine.UI.Label()
    self.icon:SetParent(self)
    self.icon:SetSize(20, 20)
    self.icon:SetPosition(30, 10)
    self.icon:SetBackground(Icons[player:GetClass()])
    self.icon:SetMouseVisible(false)

    self.label = Turbine.UI.Label()
    self.label:SetParent(self)
    self.label:SetSize(80, 32)
    self.label:SetPosition(0,32)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiqua18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetMouseVisible(false)
    self.label:SetVisible(true)
    self.label:SetOutlineColor(Turbine.UI.Color(0,0,0))
    --self.label:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.label:SetText(player:GetName())
    self.label:SetForeColor(Turbine.UI.Color(1, 1, 1))

    self.scrollOffensiveLabel = Turbine.UI.Label()
    self.scrollOffensiveLabel:SetParent(self)
    self.scrollOffensiveLabel:SetSize(80, 32)
    self.scrollOffensiveLabel:SetPosition(0,32 + 32)
    self.scrollOffensiveLabel:SetMouseVisible(false)
    self.scrollOffensiveLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiqua26)
    self.scrollOffensiveLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.scrollOffensiveLabel:SetOutlineColor(OutlineColor)
    self.scrollOffensiveLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)

    self.scrollDefensiveLabel = Turbine.UI.Label()
    self.scrollDefensiveLabel:SetParent(self)
    self.scrollDefensiveLabel:SetSize(80, 32)
    self.scrollDefensiveLabel:SetPosition(0,64 + 32)
    self.scrollDefensiveLabel:SetMouseVisible(false)
    self.scrollDefensiveLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiqua26)
    self.scrollDefensiveLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.scrollDefensiveLabel:SetOutlineColor(OutlineColor)
    self.scrollDefensiveLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)

    self.hopeLabel = Turbine.UI.Label()
    self.hopeLabel:SetParent(self)
    self.hopeLabel:SetSize(80, 32)
    self.hopeLabel:SetPosition(0,96 + 32)
    self.hopeLabel:SetMouseVisible(false)
    self.hopeLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiqua26)
    self.hopeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.hopeLabel:SetOutlineColor(OutlineColor)
    self.hopeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)

    self.dbLabel = Turbine.UI.Label()
    self.dbLabel:SetParent(self)
    self.dbLabel:SetSize(80, 32)
    self.dbLabel:SetPosition(0,128 + 32)
    self.dbLabel:SetMouseVisible(false)
    self.dbLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiqua26)
    self.dbLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.dbLabel:SetOutlineColor(OutlineColor)
    self.dbLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)

    local effectList = player:GetEffects()

    local PlayerEffects = {}
    local hope = false
    local oScrolls = false
    local dScrolls = false
    local dB = false
    for i = 1, effectList:GetCount(), 1 do
        PlayerEffects[effectList:Get(i):GetName()] = true
        --ChatOutput(player:GetName() .. effectList:Get(i):GetName())
        if string.find(effectList:Get(i):GetName(), "Battle Lore") then oScrolls = true end
        if string.find(effectList:Get(i):GetName(), "Warding Lore") then dScrolls = true end
        if string.find(effectList:Get(i):GetName(), "Token: Give Hope") then hope = true end
        if string.find(effectList:Get(i):GetName(), "Duty Bound") then dB = true end
    end

    if oScrolls then
        --self.scrollOffensiveLabel:SetBackground(1090642112)
        self.scrollOffensiveLabel:SetText("O")
        self.scrollOffensiveLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    else
        self.scrollOffensiveLabel:SetText("X")
        self.scrollOffensiveLabel:SetForeColor(Turbine.UI.Color.Crimson)
    end

    if dScrolls then
        self.scrollDefensiveLabel:SetText("O")
        self.scrollDefensiveLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    else
        self.scrollDefensiveLabel:SetText("X")
        self.scrollDefensiveLabel:SetForeColor(Turbine.UI.Color.Crimson)
    end

    if hope then
        self.hopeLabel:SetText("O")
        self.hopeLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    else
        self.hopeLabel:SetText("X")
        self.hopeLabel:SetForeColor(Turbine.UI.Color.Crimson)
    end

    if dB then
        self.dbLabel:SetText("O")
        self.dbLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    else
        self.dbLabel:SetText("X")
        self.dbLabel:SetForeColor(Turbine.UI.Color.Crimson)
    end

    local effectList = player:GetEffects()

    local PlayerEffects = {}
    local hope = false
    local oScrolls = false
    local dScrolls = false
    local dB = false
    for i = 1, effectList:GetCount(), 1 do
        PlayerEffects[effectList:Get(i):GetName()] = true
        --ChatOutput(player:GetName() .. effectList:Get(i):GetName())
        if string.find(effectList:Get(i):GetName(), "Battle Lore") then oScrolls = true end
        if string.find(effectList:Get(i):GetName(), "Warding Lore") then dScrolls = true end
        if string.find(effectList:Get(i):GetName(), "Token: Give Hope") then hope = true end
        if string.find(effectList:Get(i):GetName(), "Duty Bound") then dB = true end
    end

    if oScrolls then
        --self.scrollOffensiveLabel:SetBackground(1090642112)
        self.scrollOffensiveLabel:SetText("O")
        self.scrollOffensiveLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    end

    if dScrolls then
        self.scrollDefensiveLabel:SetText("O")
        self.scrollDefensiveLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    end

    if hope then
        self.hopeLabel:SetText("O")
        self.hopeLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    end

    if dB then
        self.dbLabel:SetText("O")
        self.dbLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    end

    

    self.ScropeState = function(sender, buffname)
        --ChatOutput(buffname)
        if string.find(buffname,"Battle Lore") then
            --self.scrollOffensiveLabel:SetBackground(1090642112)
            self.scrollOffensiveLabel:SetText("O")
            self.scrollOffensiveLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
        end
    
        if string.find(buffname, "Warding Lore") then
            self.scrollDefensiveLabel:SetText("O")
            self.scrollDefensiveLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
        end
    
        if string.find(buffname, "Token: Give Hope") then
            self.hopeLabel:SetText("O")
            self.hopeLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
        end

        if string.find(buffname, "Duty Bound") then
            self.dbLabel:SetText("O")
            self.dbLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
        end
    end

    self.UpdateReadyState = function(sender, state)
        if state then
            self.label:SetForeColor(Turbine.UI.Color(0, 1, 0))
        else
            self.label:SetForeColor(Turbine.UI.Color(1, 0, 0))
        end
    end

    --ChatOutput(player:GetName() .. "Made Label")

end



--Duty Bound 1090553996
--Dwarf Endurance 1090554033

ReadyButtonWindow = class(Turbine.UI.Window)
function ReadyButtonWindow:Constructor()
    local buttonUpdate = Turbine.Engine.GetGameTime()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(32, 32)
    --self:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self:SetVisible(false)
    self:SetPosition(math.floor( Turbine.UI.Display.GetWidth() / 2 - 16), math.floor( Turbine.UI.Display.GetHeight() / 2 - 16))
    self:SetMouseVisible(true)
    self:SetWantsKeyEvents(true)
    --self:SetWantsUpdates(true)

    self.readyButton = Turbine.UI.Lotro.Quickslot()
    self.readyButton:SetParent(self)
    self.readyButton:SetUseOnRightClick(false)
    self.readyButton:SetShortcut()
    self.readyButton:SetParent(self)
    self.readyButton:SetMouseVisible(true)
    self.readyButton:SetWantsKeyEvents(true)
    self.readyButton:SetSize(32, 32)
    --self.readyButton:SetWantsUpdates(true)

    self.VisibleChanged = function()
        if Party ~= nil then 
            local channel = "f"
            if Party:GetMemberCount() > 6 then
                channel = "ra"
            end
            self.readyButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. channel .. " " .. " Initiate Readycheck"))
        end
    end
end

ReadyLabel2 = class(Turbine.UI.Control)
function ReadyLabel2:Constructor(player, parent, index)
    Turbine.UI.Control.Constructor(self);
    self:SetParent(parent)
    self:SetVisible(true)
    self:SetSize(200, 30)
    self:SetPosition(0, 10 + 30 * index)
    --self:SetBackColor(Turbine.UI.Color( math.random(), math.random(), math.random() ) )
    self:SetMouseVisible(false)
    --self:SetWantsUpdates(true)

    self.icon = Turbine.UI.Label()
    self.icon:SetParent(self)
    self.icon:SetSize(20, 20)
    self.icon:SetPosition(6, 6)
    self.icon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
    self.icon:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.icon:SetBackground(Icons[player:GetClass()])
    self.icon:SetMouseVisible(false)

    self.label = Turbine.UI.Label()
    self.label:SetParent(self)
    self.label:SetSize(200, 32)
    self.label:SetPosition(30, 0)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiqua18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetMouseVisible(false)
    self.label:SetVisible(true)
    self.label:SetMultiline(false)
    self.label:SetOutlineColor(Turbine.UI.Color(0,0,0))
    --self.label:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.label:SetText(player:GetName())
    self.label:SetForeColor(Turbine.UI.Color(1, 1, 1))

end

function ReadyLabel2:UpdateReadyState(state)
    if state then
        self.label:SetForeColor(Turbine.UI.Color(0, 1, 0))
    else
        self.label:SetForeColor(Turbine.UI.Color(1, 0, 0))
    end
end
