Settings = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeSettings")

function GetDefaultSettings()
    Settings = {}

    Settings.Reload = false
    Settings.Version = PluginVersion

    -- CountdownWindow
    Settings.CWidth = 250
    Settings.CHeight = 125
    Settings.CX = math.floor(Turbine.UI.Display.GetWidth() / 2 - (Settings.CWidth /2))
    Settings.CY = math.floor(Turbine.UI.Display.GetHeight() / 2 - (Settings.CHeight))
    Settings.CFont = Turbine.UI.Lotro.Font.TrajanProBold36
    Settings.COpacity = 1

    -- EffectsWindow
    Settings.EWidth = 750
    Settings.EHeight = 125
    Settings.EX = math.floor(Turbine.UI.Display.GetWidth() / 2 - (Settings.EWidth/2) - 2)
    Settings.EY = math.floor(Turbine.UI.Display.GetHeight() / 3)
    Settings.EEnabled = true
    Settings.EFont = Turbine.UI.Lotro.Font.TrajanProBold36
    Settings.EL = true
    Settings.ER = true
    Settings.EIWidth = 100
    Settings.EIHeight = 100
    Settings.EOpacity = 1

    -- NoteWindow
    Settings.NoteWidth = 300
    Settings.NoteHeight = 450
    Settings.NoteX = 0
    Settings.NoteY = 0
    Settings.NoteOpacity = 1

    -- MessageWindow
    Settings.MWidth = 750
    Settings.MHeight = 125
    Settings.MX = math.floor(Turbine.UI.Display.GetWidth() / 2 - (Settings.MWidth/2) - 2)
    Settings.MY = math.floor(Turbine.UI.Display.GetHeight() / 3 - (Settings.MHeight))
    Settings.MEnabled = true
    Settings.MFont = Turbine.UI.Lotro.Font.TrajanProBold36
    Settings.ML = true
    Settings.MR = true
    Settings.MIWidth = 100
    Settings.MIHeight = 100
    Settings.MOpacity = 1
    Settings.Brickit = false

    -- Skill Counters
    Settings.SWidth = 250
    Settings.SHeight = 750
    Settings.SNewWidth = 200
    Settings.SNewHeight = 200
    Settings.SX = math.floor(Turbine.UI.Display.GetWidth() / 2 - (Settings.SNewWidth/2))
    Settings.SY = math.floor(Turbine.UI.Display.GetHeight() / 2)
    Settings.SX2 = math.floor(Turbine.UI.Display.GetWidth() / 2 - (Settings.SNewWidth/2))
    Settings.SY2 = math.floor(Turbine.UI.Display.GetHeight() / 2)
    Settings.SItemWidth = Settings.SWidth
    Settings.SItemHeight = Settings.SHeight
    Settings.SEnabled = true
    Settings.SFont = Turbine.UI.Lotro.Font.TrajanProBold24
    Settings.STimers = Turbine.UI.Lotro.Font.TrajanProBold36
    Settings.STimerWidth = Settings.SWidth
    Settings.STimerHeight = 25
    Settings.SOpacity = 1
    Settings.SNewTimer = 20
    Settings.SNewFont = Turbine.UI.Lotro.Font.TrajanPro14

    -- Skill Timers
    Settings.SPWidth2 = 200
    Settings.SPHeight2 = 500
    Settings.SPX2 = 0
    Settings.SPY2 = 0
    Settings.SPItemWidth = Settings.SPWidth
    Settings.SPItemHeight = Settings.SPHeight
    Settings.SPEnabled = true
    Settings.SPFont = Turbine.UI.Lotro.Font.TrajanProBold24
    Settings.SPTimers = Turbine.UI.Lotro.Font.TrajanProBold36
    Settings.SPNewFont = Turbine.UI.Lotro.Font.TrajanPro14
    Settings.SPTimerWidth = Settings.SPWidth
    Settings.SPTimerHeight = 32
    Settings.SPTimerHeight2 = 34
    Settings.SPOpacity = 1

    Settings.SPAX = 0
    Settings.SPAY = 0
    Settings.SPAWidth = 200
    Settings.SPAHeight = 300
    Settings.SPAEnabled = true

    Settings.SPCDEnabled = true
    Settings.SPActiveEnabled = true

    -- Log window
    Settings.LWidth = 250
    Settings.LHeight = 750
    Settings.LX = 0
    Settings.LY = 0
    Settings.LEnabled = false
    Settings.LOpacity = 1

    -- Combat Timer
    Settings.CTWidth = 100
    Settings.CTHeight = 100
    Settings.CTX = Turbine.UI.Display.GetWidth() / 3
    Settings.CTY = Turbine.UI.Display.GetHeight() - 300
    Settings.CTEnabled = true
    Settings.CTFont = Turbine.UI.Lotro.Font.TrajanProBold36
    Settings.CTOpacity = 1
    Settings.CTOverride = false

    -- Leader window
    Settings.LWEnabled = false
    Settings.LWOpacity = 1

    -- Loot window
    Settings.LOEnabled = true
    Settings.LOWidth = 750
    Settings.LOHeight = 750
    Settings.LOX = math.floor(Turbine.UI.Display.GetWidth() / 2 - (Settings.LOWidth /2))
    Settings.LOY =  math.floor(Turbine.UI.Display.GetHeight() / 2 - (Settings.LOHeight /2))
    Settings.LOFont = Turbine.UI.Lotro.Font.Verdana14
    Settings.LOOpacity = 1
    Settings.LOBFont = Turbine.UI.Lotro.Font.VerdanaBold16

    -- Options button
    Settings.OX = 0
    Settings.OY = Turbine.UI.Display.GetHeight() - 20

    -- RatTracker
    Settings.REnabled = false
    Settings.RWidth = 300
    Settings.RHeight = 20 * 17
    Settings.RX = 0
    Settings.RY = 0

    -- Skill Window
    Settings.SWWidth = 100
    Settings.SWX = 500
    Settings.SWY = 500
    Settings.SWVisible = true

    -- Alert Window
    Settings.AOffset = 10
    Settings.AWidth = 600
    Settings.AItemCount = 15
    Settings.AHeight = (Settings.AOffset + 32) * Settings.AItemCount 
    Settings.ABaseHeight = 32
    Settings.AX = math.floor(Turbine.UI.Display.GetWidth() / 2 - (Settings.AWidth/2)) + 100
    Settings.AY = math.floor(Turbine.UI.Display.GetHeight() / 3 - (Settings.AHeight))
    Settings.AEnabled = true
    Settings.AFont = Turbine.UI.Lotro.Font.TrajanProBold24
    Settings.AL = true
    Settings.AR = false
    Settings.AIWidth = 32
    Settings.AIHeight = 32
    Settings.AOpacity = 1

    -- Target window
    Settings.TWidth = 200
    Settings.THeight = 400
    Settings.THeight2 = 300
    Settings.TX = 500
    Settings.TY = 500
    Settings.TEnabled = true
    Settings.TEffects = true
    Settings.TOverride = false
    Settings.TShowAll = false

    Settings.ReloadData = false

    -- Instance controller
    Settings.InstanceState = false
    Settings.EttenmoorsState = false
    Settings.InstanceVersion = 0
    Settings.InstanceTier = 0

    -- Skill overlay
    Settings.SkillbarScale = 1

    -- Daily reset
    Settings.LastDailyReset = 0

    -- PvMP Tools
    Settings.KBVisible = true
    Settings.KBX = 500
    Settings.KBY = 0

    -- PvP Timers
    Settings.PPWidth = 200
    Settings.PPHeight = 200
    Settings.PPX = 700
    Settings.PPY = 500

    -- Skill Alerts
    Settings.SKAEnabled = false
    Settings.SKTEnabled = true

    -- First Time Setup
    Settings.FirstTime = true

    -- Sound Player
    Settings.Sound = true

    -- Target Boxes
    Settings.TBEnabled = true
    Settings.TBX = math.floor(Turbine.UI.Display.GetWidth() / 4)
    Settings.TBY = math.floor(Turbine.UI.Display.GetHeight() / 3)

    -- Swap reset
    Settings.SwapToken = 1

    -- Advanced
    Settings.Advanced = false
    Settings.CheckLag = false

end

if Settings == nil or Settings.Reload == true then
    GetDefaultSettings()
end

function UpdateSettings()
    local tempSettings = Settings
    GetDefaultSettings()
    for key, value in pairs(tempSettings) do
        if Settings[key] ~=  nil then
            Settings[key] = value
        end
    end
    if plugin:GetVersion() ~= tempSettings.Version then
        Settings.FirstTime = true
    end
    Settings.Version = plugin:GetVersion()
end



function SaveData()
    ReloadData = {}
    ReloadData.Note =  noteWindow.noteWindow:GetText()
    if Settings.ReloadData then
        if Settings.AEnabled and rezTracker then  ReloadData.DNFS = rezTracker:GetDNFS() end
    end
    ReloadData.Countdown = countdownWindow:GetCountdown()
    Turbine.PluginData.Save(Turbine.DataScope.Server, "PrimeReloadData", ReloadData);


    Settings.OX, Settings.OY = optionsButton:GetPosition()
    Settings.CX, Settings.CY = countdownWindow:GetPosition()
    Settings.NoteX, Settings.NoteY = noteWindow:GetPosition()
    if Target ~= nil then Settings.TX, Settings.TY = Target:GetPosition() end
    if effectsWindow ~= nil then Settings.EX, Settings.EY = effectsWindow:GetPosition() end
    if messageWindow ~= nil then Settings.AX, Settings.AY = messageWindow:GetPosition() end
    if skillCounters ~= nil then Settings.SX2, Settings.SY2 = skillCounters:GetPosition() end
    if skillTimers ~= nil then Settings.SPX2, Settings.SPY2 = skillTimers:GetPosition() end
    if activeTimers ~= nil then Settings.SPAX, Settings.SPAY = activeTimers:GetPosition() end
    if logWindow ~= nil then Settings.LX, Settings.LY = logWindow:GetPosition() end
    if combatTimer ~= nil then Settings.CTX, Settings.CTY = combatTimer:GetPosition() end
    --if ratTracker ~= nil then Settings.RX, Settings.RY = ratTracker:GetPosition() end
    --Settings.SWVisible = skillWindow:IsVisible()
    Settings.SWX, Settings.SWY = skillWindow:GetPosition()
    if KillTracker ~= nil then Settings.KBX, Settings.KBY = KillTracker:GetPosition() end
    if PVPCDTracker ~= nil then Settings.PPX, Settings.PPY = PVPCDTracker:GetPosition() end
    if targetBox then Settings.TBX, Settings.TBY = targetBox:GetPosition() end
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeSettings", Settings);
    --Note window
    --DNFS

    -- Target window settings handling
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeRemovedTargetEffects", RemovedBasicEffects)
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeAddedTargetEffects", AddedCharEffects) 

    SaveableSkillBars = {}

    for _, value in pairs(ActiveSkillBars) do
        SaveableSkillBars[value:GetBarName()] = value:GetSkillName()
    end

    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeSkillBars", SaveableSkillBars)

    for _, value in pairs(ActiveSkillBars) do
        local x, y = value:GetPosition()
        SkillBarsPositions[value:GetBarName()] = {x, y}
    end

    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeSkillBarsPositions", SkillBarsPositions)

    -- All effect settings handling
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeRemovedPlayerEffectsAll", RemovedBasicPlayerEffectsAll)
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeAddedPlayerEffectsAll", AddedCharPlayerEffectsAll) 

    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeRemovedPlayerEffectsSelf", RemovedBasicPlayerEffectsSelf)
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeAddedPlayerEffectsSelf", AddedCharPlayerEffectsSelf) 

    -- Skill timers settings handling
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeRemovedSkillTimersAll", RemovedBasicSkillTimersAll)
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeAddedSkillTimersAll", AddedCharSkillTimersAll) 

    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeRemovedSkillTimersSpecific", RemovedBasicSkillTimersSpecific)
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeAddedSkillTimersSpecific", AddedCharSkillTimersSpecific) 

    -- Chat alerts handling
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeRemovedChatAlerts", RemovedChatAlerts) 
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeAddedChatAlerts", AddedChatAlerts)

    -- Loot handling
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeRemovedRaidChests", RemovedRaidChests)
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeAddedRaidChests", AddedRaidChests)

    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeRemovedInstanceChests", RemovedInstanceChests)
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeAddedInstanceChests", AddedInstanceChests)

    -- Buff window
    Turbine.PluginData.Save(Turbine.DataScope.Character, "PrimeBuffWindows", BuffWindows)
    
    -- Save swaps
    SwappyWarner:SaveData()
end