SkillCounters = class(Turbine.UI.Window)
function SkillCounters:Constructor()
    self.width = Settings.SNewWidth
    local height = Settings.SNewHeight
    local x = Settings.SX2
    local y = Settings.SY2
    local cooldownTimer = 0
    local oldGameTime = Turbine.Engine.GetGameTime()
    self.Timers = {}
    local ID = 0
    self.resort = false
    Turbine.UI.Window.Constructor(self);
    self:SetSize(self.width,height);
    self:SetPosition(x,y);
    self:SetZOrder(1);

    self:SetMouseVisible(false)
    self:SetVisible(true)
    --self:SetWantsUpdates(true)
    --Updater:Subscribe(self)

    self.messageBox = Turbine.UI.Label()
    self.messageBox:SetParent(self)
    self.messageBox:SetSize(self.width,height)
    self.messageBox:SetPosition(0,0)
    self.messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox:SetFont(Settings.SFont)
    self.messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox:SetMouseVisible(false)
    self.messageBox:SetVisible(false)
  
    local moveBox = MoveBox(self, self.width, height, "Boss CDs")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.Clear = function()
        for key, value in pairs(self.Timers) do 
            value[1]:Destroy()
            self.Timers[key] = nil
            --table.remove(self.Timers, key )
            --PrintTable(self.Timers)
        end
    
        if Tablelength(self.Timers) > 0 then
            self.Clear()
        end
        self.Timers = nil
        collectgarbage()
        self.Timers = {}
    end

    self.ResortList = function()
        local counter = 0
        for _,v in spairs(self.Timers, function(t,a,b) return t[b][2] > t[a][2] end) do
            v[1]:SetPosition(0, counter * Settings.SNewTimer) 
            counter = counter + 1
        end

        self.resort = false
    end
end

function SkillCounters:ExecuteUpdate(delta)    
    --We had an update
    for key, value in pairs(self.Timers) do 
        --ChatOutput(value[2])
        value[2] = value[2] - delta
        value[1]:UpdateText(delta)
        if value[2] < 0 then 
            value[1]:Destroy()
            self.Timers[key] = nil
            self.resort = true
        end
        --value[1]:SetText(value[3].." "..value[2])
    end
    if self.resort then 
        if tablelength(self.Timers) == 0 then 
            Updater:UnSubscribe(self) 
            self.Timers = nil
            collectgarbage()
            self.Timers = {}
            return
        end
        self.ResortList() 
    end
end
-- Add a timer
function SkillCounters:NewTimer(duration, message, unique)
    local count = tablelength(self.Timers)
    if unique then
        for key, value in pairs(self.Timers) do
            if value[3] == message then 
                return
             end
        end
    end
    --self.Timers[ID] =  {Counter(self, width, height, count, duration, message), duration, message}
    self.Timers[#self.Timers + 1] = {Counter2(self, self.width, Settings.SNewTimer, count, duration, message, Settings.SNewFont, Turbine.UI.Color(1,0,0), Turbine.UI.Color(0.5,0,0), Turbine.UI.Color(0,0.125,0.5), Turbine.UI.Color(0,0.6,7), Turbine.UI.Color(0,0.0,0.8), nil, nil), duration, message}
    --ID = ID + 1
    self.resort = true
    Updater:Subscribe(self)
    --PrintTable(self.Timers)
end
