SkillTimers = class(Turbine.UI.Window)
function SkillTimers:Constructor(timerType)
    self.width = 0
    local height = 0
    local x = 0
    local y = 0
    self.showTimers = nil
    self.Name = nil
    if timerType == 0 then 
        self.width = Settings.SPWidth2
        height = Settings.SPHeight2
        x = Settings.SPX2
        y = Settings.SPY2
        self.showTimers = Settings.SPCDEnabled
        self.Name = "Cooldown Timers"
    else
        self.width = Settings.SPAWidth
        height = Settings.SPAHeight
        x = Settings.SPAX
        y = Settings.SPAY
        self.showTimers = Settings.SPActiveEnabled
        self.Name = "Active Timers"
    end
    local cooldownTimer = 0
    local oldGameTime = Turbine.Engine.GetGameTime()
    self.Timers = {}
    local ID = 0
    local clearTimer = 0
    self.TimerType= timerType
    self.resort = false

    Turbine.UI.Window.Constructor(self);
    self:SetSize(self.width,height);
    self:SetPosition(x,y);
    self:SetZOrder(1);

    self:SetMouseVisible(false)
    self:SetVisible(true)
    --self:SetWantsUpdates(true)

    self.messageBox = Turbine.UI.Label()
    self.messageBox:SetParent(self)
    self.messageBox:SetSize(self.width,height)
    self.messageBox:SetPosition(0,0)
    self.messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox:SetFont(Settings.SPFont)
    self.messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox:SetMouseVisible(false)
    self.messageBox:SetVisible(false)
  
    local moveBox = MoveBox(self, self.width, height, self.Name)
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.Clear = function()
        for key, value in pairs(self.Timers) do 
            value[1]:Destroy()
            self.Timers[key] = nil
        end

        if Tablelength(self.Timers) > 0 then
            self.Clear()
        end

        self.Timers = nil
        collectgarbage()
        self.Timers = {}
    end

    self.Compare = function(a, b)
        if a ~= nil and b ~= nil then
            return a[2] < b[2]
        end
    end

    self.ResortList = function()
        local counter = 0
        for _,v in spairs(self.Timers, function(t,a,b) return t[b][2] > t[a][2] end) do
            v[1]:SetPosition(0, counter * Settings.SPTimerHeight2) 
            counter = counter + 1
        end

        self.resort = false
    end
end

-- Add a timer
function SkillTimers:NewTimer(duration, effectName, message, unique, activityTimer, showActivity, icon, name)
    if not(self.showTimers) then return end
    local count = tablelength(self.Timers)
    local timerMessage = ""
    if unique then
        if activityTimer == nil then ChatOutput("Nill timer for: " .. effectName) end
        for key, value in pairs(self.Timers) do
            --ChatOutput(value[4] .. " " .. effectName)
            if value[4] == effectName and (self.TimerType == 1 or duration - activityTimer < value[1]:GetRemainingTime()) then 
                --ChatOutput("Return")
                return
            end
        end
    end

    if E.BetterEffectIcons[effectName] ~= nil then
        icon = E.BetterEffectIcons[effectName]
    end

    if showActivity ~= nil and self.TimerType ==  1 then
        if not(E.GroupEffectsActive[effectName]) then
            timerMessage = name
        else
            timerMessage = message
        end
        self.Timers[#self.Timers + 1] = {Counter(self, self.width, Settings.SPTimerHeight2, count, activityTimer, timerMessage, Settings.SPNewFont, TimerColourActive1, TimerColourActive2, TimerColourActive3, TimerColourActive4, TimerColourActive5, icon), activityTimer, timerMessage, effectName, unique}
        --count = count + 1
    end
            --self.Timers[ID] =  {Counter(self, self.width, height, count, duration, message), duration, message}
    if self.TimerType == 0 then
        if not(E.GroupEffectsCooldown[effectName]) then
            timerMessage = name
        else
            timerMessage = message
        end
        self.Timers[#self.Timers + 1] = {Counter(self, self.width, Settings.SPTimerHeight2, count, duration, timerMessage, Settings.SPNewFont, TimerColourNormal1, TimerColourNormal2, TimerColourNormal3, TimerColourNormal4, TimerColourNormal5, icon), duration, timerMessage, effectName, unique}
    end

    --ID = ID + 1
    self.resort = true

    Updater:Subscribe(self)
    --PrintTable(self.Timers)
end

function SkillTimers:ExecuteUpdate(delta)   
    --We had an update
    for key, value in pairs(self.Timers) do 
        value[2] = value[2] - delta
        value[1]:UpdateText(delta)
        if value[2] < 0 then 
            --PrintTable(self.Timers)
            --ChatOutput("Delete ID: " .. key)
            value[1]:Destroy()
            self.Timers[key] = nil
            --PrintTable(self.Timers)
            self.resort = true
        end
        --value[1]:SetText(value[3].." "..value[2])
    end

    if self.resort then 
        if tablelength(self.Timers) == 0 then 
            Updater:UnSubscribe(self) 
            self.Timers = nil
            collectgarbage()
            self.Timers = {}
            return
        end
        self.ResortList() 
    end
end




