TargetWindowOptions = class(Turbine.UI.Control)
function TargetWindowOptions:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetParent(parent)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(0,-20);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(self)
    InfoLabel:SetSize(200, 100)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(300, 200)
    InfoLabel:SetVisible(false)
    InfoLabel:SetText("Reload the plugin to see the effects of your actions. Sometimes it requires time so you need to reload an additional time in order for the data to be loaded correctly!")

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(30, 35)
    DescriptionLabel:SetText("Currently shown effects: ")

    local ItemSelectedInfoLabel = Turbine.UI.Label()
    ItemSelectedInfoLabel:SetParent(self)
    ItemSelectedInfoLabel:SetSize(200, 15)
    ItemSelectedInfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemSelectedInfoLabel:SetMouseVisible(false)
    ItemSelectedInfoLabel:SetPosition(300, 50)
    ItemSelectedInfoLabel:SetText("Item selected:")

    local ItemSelectedLabel = Turbine.UI.Label()
    ItemSelectedLabel:SetParent(self)
    ItemSelectedLabel:SetSize(200, 15)
    ItemSelectedLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemSelectedLabel:SetMouseVisible(false)
    --ItemSelectedLabel:SetMultiline(false)
    ItemSelectedLabel:SetPosition(300, 70)

    local RemoveButton = Turbine.UI.Lotro.Button()
    RemoveButton:SetParent(self)
    RemoveButton:SetSize(100, 15)
    RemoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    RemoveButton:SetMouseVisible(false)
    RemoveButton:SetPosition(300, 90)
    RemoveButton:SetText("Remove Item")

    RemoveButton.Click = function()
        --TargetEffects[ItemSelectedLabel:GetText()] = nil
        if AddedCharEffects[ItemSelectedLabel:GetText()] then 
            AddedCharEffects[ItemSelectedLabel:GetText()] = nil
        else
            RemovedBasicEffects[ItemSelectedLabel:GetText()] = true
        end
        ChatOutput("Removed effect: " .. ItemSelectedLabel:GetText())
        InfoLabel:SetVisible(true)
    end

    local AddButton = Turbine.UI.Lotro.Button()
    AddButton:SetParent(self)
    AddButton:SetSize(100, 15)
    AddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    AddButton:SetMouseVisible(false)
    AddButton:SetPosition(400, 90)
    AddButton:SetText("Add Item")

    AddButton.Click = function()
        --TargetEffects[ItemSelectedLabel:GetText()] = true
        RemovedBasicEffects[ItemSelectedLabel:GetText()] = nil
        ChatOutput("ReAdded effect: " .. ItemSelectedLabel:GetText())
        InfoLabel:SetVisible(true)
    end

    local container = Turbine.UI.ListBox()
    container:SetParent(self)
    container:SetSize(200, height - 100)
    container:SetPosition(30, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    containerScrollbar:SetParent( self );
    containerScrollbar:SetPosition( 230 - 10, 50 );
    containerScrollbar:SetSize( 10, height - 100 );
    container:SetVerticalScrollBar( containerScrollbar );

    local sortedEffects = {}
    for key, value in pairs(TargetWindowEffects) do table.insert( sortedEffects,key ) end
    table.sort( sortedEffects )

    for key, value in pairs(sortedEffects) do
        AddListItem(value, container, ItemSelectedLabel)
    end

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(300, 130)
    DescriptionLabel:SetText("Enter Effect:")

    local ItemTextBox = Turbine.UI.Lotro.TextBox()
    ItemTextBox:SetParent(self)
    ItemTextBox:SetSize(200, 30)
    ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox:SetMouseVisible(false)
    ItemTextBox:SetPosition(300, 150)

    local TextAddButton = Turbine.UI.Lotro.Button()
    TextAddButton:SetParent(self)
    TextAddButton:SetSize(200, 15)
    TextAddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    TextAddButton:SetMouseVisible(false)
    TextAddButton:SetPosition(300, 180)
    TextAddButton:SetText("Add Effect")

    TextAddButton.Click = function()
        --TargetEffects[ItemSelectedLabel:GetText()] = true
        AddedCharEffects[ItemTextBox:GetText()] = true
        ChatOutput("Added effect: " .. ItemTextBox:GetText())
        InfoLabel:SetVisible(true)
    end

    local RemovedDescriptionLabel = Turbine.UI.Label()
    RemovedDescriptionLabel:SetParent(self)
    RemovedDescriptionLabel:SetSize(200, 15)
    RemovedDescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    RemovedDescriptionLabel:SetMouseVisible(false)
    RemovedDescriptionLabel:SetPosition(530, 35)
    RemovedDescriptionLabel:SetText("Currently deleted effects: ")

    local removedContainer = Turbine.UI.ListBox()
    removedContainer:SetParent(self)
    removedContainer:SetSize(200, height - 100)
    removedContainer:SetPosition(530, 50)
    --removedContainer:SetBackColor(GoldColor)
    removedContainer:SetVisible(true)
    removedContainer:SetWantsKeyEvents(true)
    removedContainer:SetMouseVisible(true)

    local removedContainerScrollbar = Turbine.UI.Lotro.ScrollBar();
    removedContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    removedContainerScrollbar:SetParent( self );
    removedContainerScrollbar:SetPosition( 730 - 10, 50 );
    removedContainerScrollbar:SetSize( 10, height - 100 );
    removedContainer:SetVerticalScrollBar( removedContainerScrollbar );

    local RemovedSortedEffects = {}
    for key, value in pairs(RemovedBasicEffects) do table.insert( RemovedSortedEffects,key ) end
    table.sort( RemovedSortedEffects )

    for key, value in pairs(RemovedSortedEffects) do
        AddListItem(value, removedContainer, ItemSelectedLabel)
    end

    -- Width Height
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(self)
    UIElement:SetPosition(280, 300)
    UIElement:SetSize(400, 100)

    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(20 , 0);
    UIElement.windowLabel:SetSize(200,15);
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    UIElement.windowLabel:SetVisible(true);
    UIElement.windowLabel:SetText( "Width              Height");

    UIElement.windowX = Turbine.UI.TextBox()
    UIElement.windowX:SetParent(UIElement)
    UIElement.windowX:SetBackColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowX:SetForeColor(Turbine.UI.Color(0, 0, 0))
    UIElement.windowX:SetPosition(20 , 15);
    UIElement.windowX:SetSize(100,15);
    UIElement.windowX:SetText(Settings.TWidth)
    UIElement.windowX:SetVisible(true);

    UIElement.windowY = Turbine.UI.TextBox()
    UIElement.windowY:SetParent(UIElement)
    UIElement.windowY:SetBackColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowY:SetForeColor(Turbine.UI.Color(0, 0, 0))
    UIElement.windowY:SetPosition(130 , 15);
    UIElement.windowY:SetSize(100,15);
    UIElement.windowY:SetText(Settings.THeight2)
    UIElement.windowY:SetVisible(true);

    UIElement.button = Turbine.UI.Lotro.Button()
    UIElement.button:SetParent(UIElement)
    UIElement.button:SetPosition(80 , 35);
    UIElement.button:SetSize(100,15);
    UIElement.button:SetText("Apply change");
    UIElement.button:SetVisible(true);

    UIElement.button.Click = function()
        Settings.TWidth = UIElement.windowX:GetText()
        Settings.THeight2 = UIElement.windowY:GetText()
        ReloadPlugin()
    end

    -- Enable/Disable whole window

    local UIElement2 = Turbine.UI.Control()
    UIElement2:SetParent(self)
    UIElement2:SetPosition(220, 350)
    UIElement2:SetSize(200, 20)

    UIElement2.cBox = Turbine.UI.Lotro.CheckBox();
    UIElement2.cBox:SetParent(UIElement2)
    UIElement2.cBox:SetPosition(15 , 0);
    UIElement2.cBox:SetSize(300,20);
    UIElement2.cBox:SetChecked(Settings.TEnabled)
    UIElement2.cBox:SetText("Toggle Targetwindow");
    UIElement2.cBox:SetVisible(true);

    UIElement2.cBox.CheckedChanged = function(sender,args)
        Settings.TEnabled = UIElement2.cBox:IsChecked()
        ReloadPlugin()
    end

    -- Enable/Disable effect tracking

    local UIElement3 = Turbine.UI.Control()
    UIElement3:SetParent(self)
    UIElement3:SetPosition(220, 380)
    UIElement3:SetSize(300, 20)

    UIElement3.cBox = Turbine.UI.Lotro.CheckBox();
    UIElement3.cBox:SetParent(UIElement3)
    UIElement3.cBox:SetPosition(15 , 0);
    UIElement3.cBox:SetSize(300,20);
    UIElement3.cBox:SetChecked(Settings.TEffects)
    UIElement3.cBox:SetText("Toggle Effect tracking");
    UIElement3.cBox:SetVisible(true);

    UIElement3.cBox.CheckedChanged = function(sender,args)
        Settings.TEffects = UIElement3.cBox:IsChecked()
        ReloadPlugin()
    end

    local UIElement4 = Turbine.UI.Control()
    UIElement4:SetParent(self)
    UIElement4:SetPosition(220, 410)
    UIElement4:SetSize(300, 20)

    UIElement4.cBox = Turbine.UI.Lotro.CheckBox();
    UIElement4.cBox:SetParent(UIElement4)
    UIElement4.cBox:SetPosition(15 , 0);
    UIElement4.cBox:SetSize(300,20);
    UIElement4.cBox:SetChecked(Settings.TShowAll)
    UIElement4.cBox:SetText("Toggle All Effect Tracking");
    UIElement4.cBox:SetVisible(true);

    UIElement4.cBox.CheckedChanged = function(sender,args)
        Settings.TShowAll = UIElement4.cBox:IsChecked()
        ReloadPlugin()
    end

    local UIElement5 = Turbine.UI.Control()
    UIElement5:SetParent(self)
    UIElement5:SetPosition(220, 440)
    UIElement5:SetSize(300, 20)

    UIElement5.cBox = Turbine.UI.Lotro.CheckBox();
    UIElement5.cBox:SetParent(UIElement5)
    UIElement5.cBox:SetPosition(15 , 0);
    UIElement5.cBox:SetSize(300,20);
    UIElement5.cBox:SetChecked(Settings.TOverride)
    UIElement5.cBox:SetText("Toggle Targetwindow Override");
    UIElement5.cBox:SetVisible(true);

    UIElement5.cBox.CheckedChanged = function(sender,args)
        Settings.TOverride = UIElement5.cBox:IsChecked()
        ReloadPlugin()
    end
end

